stages:
    - .pre
    - build
    - test
    - DeployStaging
    - deployProduction

build website:
    image: node:16-alpine
    stage: build
    script:
        - yarn install
        - yarn lint
        - yarn test
        - yarn build
    artifacts:
        paths:
            - build

test website:
    image: node:16-alpine
    stage: test
    script:
        - yarn global add serve
        - apk add curl
        - serve -s build &
        - sleep 10
        - curl http://localhost:3000 | grep "React App"

.deploy:
    image: 
        name: amazon/aws-cli:2.5.6
        entrypoint: [""]
    rules:
        - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
    script:
        - aws --version
        - echo $CI_COMMIT_REF_NAME
        - aws s3 sync build s3://$AWS_S3_BUCKET --delete
        - curl $CI_ENVIRONMENT_URL | grep "React App"

deploy to Staging:
    stage: DeployStaging
    environment: Staging
    extends: .deploy
 

deploy to Production:
    stage: deployProduction
    environment: Production
    extends: .deploy

        
